You are given coins of different denominations and a total amount of money amount. Write a function to compute the fewest number of coins that you need to make up that amount. If that amount of money cannot be made up by any combination of the coins, return -1.

Example 1:
coins = [1, 2, 5], amount = 11
return 3 (11 = 5 + 5 + 1)

Example 2:
coins = [2], amount = 3
return -1.

Note:
You may assume that you have an infinite number of each kind of coin.

Credits:
Special thanks to @jianchao.li.fighter for adding this problem and creating all test cases.

这道题给我们了一些可用的硬币值,又给了一个钱数,问我们最小能用几个硬币来找零。根据题目中的例子可知,不是每次都会给全 1,2,5 的硬币,有时候没有1分硬币,那么有的钱数就没法找零,需要返回 -1。这道题跟 CareerCup 上的那道 9.8 Represent N Cents 美分的组成 有些类似,那道题给全了所有的美分, 25,10,5,1,然后给我们一个钱数,问所有能够找零的方法,而这道题只让求出最小的那种。没啥特别好的思路就首先来考虑 brute force 吧,暴力搜索如果也没思路肿么办 -.-|||。还是来看例子1,如果不考虑代码实现,你怎么手动找出答案。博主会先取出一个最大的数字5,比目标值 11 要小,由于这里的硬币是可以重复使用的,所以博主会再取个5出来,现在是 10,还是比 11 要小,这是再取5会超,那就往前取,取2,也会超出,于是就取1,刚好是 11。那么我们的暴力搜索法也是这种思路,首先要给数组排个序,因为想要从最大的开始取,递归函数需要一个变 量start,初始化为数组的最后一个位置,当前目标值 target,还有当前使用的硬币个数 cur,以及最终结 果res。在递归函数,首先判断如果 target 小于0了,直接返回。若 target 为0了,说明当前使用的硬币已经组成了目标值,用 cur 来更新结果 res。否则就从 start 开始往前遍历硬币,对每个硬币都调用递归函数,此时 target 应该减去当前的硬币值,cur 应该自增1,代码参见评论区七楼。但是暴力搜索 Brute Force 的方法会超时 TLE,所以我们考虑一下其他的方法吧。

如果大家刷题有一阵子了的,那么应该会知道,对于求极值问题,主要考虑动态规划 Dynamic Programming 来做,好处是保留了一些中间状态的计算值,可以避免大量的重复计算。我们维护一个一维动态数组 dp,其中 dp[i] 表示钱数为i时的最小硬币数的找零,注意由于数组是从0开始的,所以要多申请一位,数组大小为 amount+1,这样最终结果就可以保存在 dp[amount] 中了。初始化 dp[0] = 0,因为目标值若为0时,就不需要硬币了。其他值可以初始化是 amount+1,为啥呢?因为最小的硬币是1,所以 amount 最多需要 amount 个硬币,amount+1 也就相当于当前的最大值了,注意这里不能用整型最大值来初始化,因为在后面的状态转移方程有加1的操作,有可能会溢出,除非你先减个1,这样还不如直接用 amount+1 舒服呢。好,接下来就是要找状态转移方程了,没思路?不要紧!回归例子1,假设我取了一个值为5的硬币,那么由于目标值是 11,所以是不是假如我们知道 dp[6],那么就知道了组成 11 的 dp 值了?所以更新 dp[i] 的方法就是遍历每个硬币,如果遍历到的硬币值小于i值(比如不能用值为5的硬币去更新 dp[3])时,用 dp[i - coins[j]] + 1 来更新 dp[i],所以状态转移方程为:

dp[i] = min(dp[i], dp[i - coins[j]] + 1);

其中 coins[j] 为第j个硬币,而 i - coins[j] 为钱数i减去其中一个硬币的值,剩余的钱数在 dp 数组中找到值,然后加1和当前 dp 数组中的值做比较,取较小的那个更新 dp 数组。先来看迭代的写法如下所示:

解法一:

class Solution {
public:
int coinChange(vector<int>& coins, int amount) {
vector<int> dp(amount + , amount + );
dp[] = ;
for (int i = ; i <= amount; ++i) {
for (int j = ; j < coins.size(); ++j) {
if (coins[j] <= i) {
dp[i] = min(dp[i], dp[i - coins[j]] + );
}
}
}
return (dp[amount] > amount) ? - : dp[amount];
}
};

迭代的 DP 解法有一个好基友,就是递归+记忆数组的解法,说其是递归形式的 DP 解法也没错,但博主比较喜欢说成是递归加记忆数组。其目的都是为了保存中间计算结果,避免大量的重复计算,从而提高运算效率,思路都一样,仅仅是写法有些区别:

解法二:

class Solution {
public:
int coinChange(vector<int>& coins, int amount) {
vector<int> memo(amount + , INT_MAX);
memo[] = ;
return coinChangeDFS(coins, amount, memo);
}
int coinChangeDFS(vector<int>& coins, int target, vector<int>& memo) {
if (target < ) return - ;
if (memo[target] != INT_MAX) return memo[target];
for (int i = ; i < coins.size(); ++i) {
int tmp = coinChangeDFS(coins, target - coins[i], memo);
if (tmp >= ) memo[target] = min(memo[target], tmp + );
}
return memo[target] = (memo[target] == INT_MAX) ? - : memo[target];
}
};

再来看一种使用 HashMap 来当记忆数组的递归解法:

解法三:

class Solution {
public:
int coinChange(vector<int>& coins, int amount) {
unordered_map<int, int> memo;
memo[] = ;
return coinChangeDFS(coins, amount, memo);
}
int coinChangeDFS(vector<int>& coins, int target, unordered_map<int, int>& memo) {
if (target < ) return - ;
if (memo.count(target)) return memo[target];
int cur = INT_MAX;
for (int i = ; i < coins.size(); ++i) {
int tmp = coinChangeDFS(coins, target - coins[i], memo);
if (tmp >= ) cur = min(cur, tmp + );
}
return memo[target] = (cur == INT_MAX) ? - : cur;
}
};

难道这题一定要 DP 来做吗,我们来看网友 hello_world00 提供的一种解法,这其实是对暴力搜索的解法做了很好的优化,不仅不会 TLE,而且击败率相当的高!对比 Brute Force 的方法,这里在递归函数中做了很好的优化。首先是判断 start 是否小于0,因为需要从 coin 中取硬币,不能越界。下面就是优化的核心了,看 target 是否能整除 coins[start],这是相当叼的一步,比如假如目标值是 15,如果当前取出了大小为5的硬币,这里做除法,可以立马知道只用大小为5的硬币就可以组成目标值 target,那么用 cur + target/coins[start] 来更新结果 res。之后的 for 循环也相当叼,不像暴力搜索中的那样从 start 位置开始往前遍历 coins 中的硬币,而是遍历 target/coins[start] 的次数,由于不能整除,只需要对余数调用递归函数,而且要把次数每次减1,并且再次求余数。举个例子,比如 coins=[1,2,3],amount=11,那么 11 除以3,得3余2,那么i从3开始遍历,这里有一步非常有用的剪枝操作,没有这一步,还是会 TLE,而加上了这一步,直接击败百分之九十九以上,可以说是天壤之别。那就是判断若 cur + i >= res - 1 成立,直接 break,不调用递归。这里解释一下,cur + i 自不必说,是当前硬币个数 cur 加上新加的i个硬币,这里 cur+i 如果大于等于 res 的话,那么 res 是不会被更新的,那么为啥这里是大于等于 res-1 呢?因为能运行到这一步,说明之前是无法整除的,那么余数一定存在,所以再次调用递归函数的 target 不为0,那么如果整除的话,cur 至少会加上1,所以又跟 res 相等了,还是不会使得 res 变得更小。解释到这里应该比较明白了吧,有疑问的请在下方留言哈,参见代码如下:

解法四:

class Solution {
public:
int coinChange(vector<int>& coins, int amount) {
int res = INT_MAX, n = coins.size();
sort(coins.begin(), coins.end());
helper(coins, n - , amount, , res);
return (res == INT_MAX) ? - : res;
}
void helper(vector<int>& coins, int start, int target, int cur, int& res) {
if (start < ) return;
if (target % coins[start] == ) {
res = min(res, cur + target / coins[start]);
return;
}
for (int i = target / coins[start]; i >= ; --i) {
if (cur + i >= res - ) break;
helper(coins, start - , target - i * coins[start], cur + i, res);
}
}
};

Github 同步地址:

https://github.com/grandyang/leetcode/issues/322

类似题目:

Coin Change 2

9.8 Represent N Cents 美分的组成

参考资料:

https://leetcode.com/problems/coin-change/

https://leetcode.com/problems/coin-change/discuss/77360/C%2B%2B-O(n*amount)-time-O(amount)-space-DP-solution

https://leetcode.com/problems/coin-change/discuss/77368/*Java*-Both-iterative-and-recursive-solutions-with-explanations

LeetCode All in One 题目讲解汇总(持续更新中...)

[LeetCode] 322. Coin Change 硬币找零的更多相关文章

  1. [LeetCode] Coin Change 硬币找零

    You are given coins of different denominations and a total amount of money amount. Write a function ...

  2. leetcode@ [322] Coin Change (Dynamic Programming)

    https://leetcode.com/problems/coin-change/ You are given coins of different denominations and a tota ...

  3. LeetCode 322. Coin Change

    原题 You are given coins of different denominations and a total amount of money amount. Write a functi ...

  4. [LeetCode] 518. Coin Change 2 硬币找零 2

    You are given coins of different denominations and a total amount of money. Write a function to comp ...

  5. LeetCode OJ 322. Coin Change DP求解

    题目链接:https://leetcode.com/problems/coin-change/ 322. Coin Change My Submissions Question Total Accep ...

  6. dp算法之硬币找零问题

    题目:硬币找零 题目介绍:现在有面值1.3.5元三种硬币无限个,问组成n元的硬币的最小数目? 分析:现在假设n=10,画出状态分布图: 硬币编号 硬币面值p 1 1 2 3 3 5 编号i/n总数j ...

  7. codevs 3961 硬币找零【完全背包DP/记忆化搜索】

    题目描述 Description 在现实生活中,我们经常遇到硬币找零的问题,例如,在发工资时,财务人员就需要计算最少的找零硬币数,以便他们能从银行拿回最少的硬币数,并保证能用这些硬币发工资. 我们应该 ...

  8. NYOJ 995 硬币找零

    硬币找零 时间限制:1000 ms  |  内存限制:65535 KB 难度:3   描述 在现实生活中,我们经常遇到硬币找零的问题,例如,在发工资时,财务人员就需要计算最少的找零硬币数,以便他们能从 ...

  9. [LeetCode] Coin Change 2 硬币找零之二

    You are given coins of different denominations and a total amount of money. Write a function to comp ...

随机推荐

  1. mysql派生查询必须有别名问题记录

    最近在做mysql sql兼容,原来是oracle的sql都要保证在mysql数据库运行 业务场景:原来是一个带有子查询的sql,在oracle是可以正常运行的,迁到mysql就发现报错了,报错信息如 ...

  2. 利用Python爬虫刷店铺微博等访问量最简单有效教程

    一.安装必要插件 测试环境:Windows 10 + Python 3.7.0 (1)安装Selenium pip install selenium (2)安装Requests pip install ...

  3. ELK 框架整体流程编写 以及logstash脚本编写

    Elasticsearch Elasticsearch 是一个实时的分布式搜索和分析引擎,它可以用于全文搜索,结构化搜索以及分析.它是一个建立在全文搜索引擎 Apache Lucene 基础上的搜索引 ...

  4. CentOS 7.6 安装htop

    yum -y install epel-release.noarch yum -y install htop htop 上面左上角显示CPU.内存.交换区的使用情况,右边显示任务.负载.开机时间,下面 ...

  5. Oracle 11g 服务端的安装步骤

    Ø  简介 本文主要介绍 Oracle 11g 服务端的安装步骤,在介绍之前说明以下几点: 1.   所安装的服务器是本机的虚拟机,操作系统为 Windows Server 2019: 2.   以下 ...

  6. 云原生生态周报 Vol. 14 | K8s CVE 修复指南

    业界要闻 Mesosphere 公司正式更名为 D2IQ, 关注云原生. Mesosophere 公司日前发布官方声明正式更名为:D2iQ(Day-Two-I-Q),称关注点转向 Kubernetes ...

  7. Java学习——反射

    Java学习——反射 摘要:本文主要讲述了什么是反射,使用反射有什么好处,以及如何使用反射. 部分内容来自以下博客: https://www.cnblogs.com/tech-bird/p/35253 ...

  8. Jquery选择器与样式操作

    jquery选择器 jquery用法思想一 选择某个网页元素,然后对它进行某种操作 jquery选择器 jquery选择器可以快速地选择元素,选择规则和css样式相同,使用length属性判断是否选择 ...

  9. 深入理解Vue组件3大核心概念

    摘要: 搞懂Vue组件! 作者:浪里行舟 原文:详解vue组件三大核心概念 Fundebug经授权转载,版权归原作者所有. 前言 本文主要介绍属性.事件和插槽这三个vue基础概念.使用方法及其容易被忽 ...

  10. 第七篇Scrum冲刺博客

    第七篇Scrum冲刺博客 一.站立式会议 提供当天站立式会议照片一张 二.每个人的工作 成员 已完成工作 明天计划完成的工作 遇到的困难 林剑峰 加入搜索页面 无 陆君健 校园卡匹配功能的实现 无 石 ...